<template>
  <div>
    <div class="blanco">
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-row>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <template v-for="(firma, indexFirma) in revisores">
                  <div :key="indexFirma">
                    <div class="subtitle-2">
                      <strong>Revisor {{ indexFirma + 1 }}</strong>
                    </div>

                    <Firmador
                      :indice="indexFirma"
                      ref="revisor"
                      :src-data="revisores"
                      :error="$v.revisores.$each[indexFirma].$error"
                      v-model="revisores[indexFirma]"
                      @valid-input="validFirma"
                    >
                      <template v-slot:delete>
                        <v-btn
                          color="red"
                          light
                          tile
                          x-small
                          right
                          class="ma-0 pa-0 white--text"
                          @click="cleared(firma)"
                        >
                          <v-icon small>mdi-delete</v-icon>
                        </v-btn>
                      </template>
                    </Firmador>
                  </div>
                </template>
              </v-col>
            </v-row>
            <v-row>
              <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3">
                <v-btn
                  class="mr-6"
                  block
                  tile
                  color="white"
                  @click="agregaRevisor"
                  >+ Agregar un revisor del documento</v-btn
                >
              </v-col>
            </v-row>
          </v-col>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-row>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <template v-for="(firma, indexFirma) in autorizadores">
                  <div :key="indexFirma">
                    <div class="subtitle-2">
                      <strong>Autorizador {{ indexFirma + 1 }}</strong>
                    </div>
                    <Firmador
                      :indice="indexFirma"
                      ref="autorizador"
                      :src-data="autorizadores"
                      :error="$v.autorizadores.$each[indexFirma].$error"
                      v-model="autorizadores[indexFirma]"
                      @valid-input="validFirma"
                    >
                      <template v-slot:delete>
                        <v-btn
                          color="red"
                          light
                          tile
                          x-small
                          right
                          class="ma-0 pa-0 white--text"
                          @click="cleared(firma)"
                        >
                          <v-icon small>mdi-delete</v-icon>
                        </v-btn>
                      </template>
                    </Firmador>
                  </div>
                </template>
              </v-col>
            </v-row>
            <v-row>
              <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3">
                <v-btn
                  class="mr-6"
                  block
                  tile
                  color="white"
                  @click="agregaAutorizador"
                  >+ Agregar un autorizador del documento</v-btn
                >
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </div>
    </div>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import Firmador from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/firmas/componentes/Firmador.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const firmaAutorizador = {
  indice: 0,
  idFirma: null,
  numeroEmpleado: null,
  idJerarquia: 2,
  idFolio: null,
};
const firmaRevisor = {
  indice: 0,
  idFirma: null,
  numeroEmpleado: null,
  idJerarquia: 1,
  idFolio: null,
};
export default {
  name: "Component-Firmas",
  components: {
    Firmador,
  },
  props: ["folio"],
  data() {
    return {
      autorizadores: [],
      revisores: [],
    };
  },
  validations: {
    revisores: {
      required,
      $each: {
        numeroEmpleado: {
          required,
        },
      },
    },
    autorizadores: {
      required,
      $each: {
        numeroEmpleado: {
          required,
        },
      },
    },
  },
  methods: {
    insertaFirmas() {
      this.revisores.forEach((item) => {
        this.postFirma(item, true);
      });
      this.autorizadores.forEach((item) => {
        this.postFirma(item, true);
      });
    },
    isValidRevisores() {
      let revisores = this.$refs["revisor"];
      let invalid = true;
      for (let index in revisores) {
        if (revisores[index].$v.$invalid) {
          invalid = false;
          break;
        }
      }
      return invalid;
    },
    touchRevisores() {
      let revisores = this.$refs["revisor"];
      for (let index in revisores) {
        revisores[index].$v.$touch();
      }
    },
    isValidAutorizadores() {
      let autorizador = this.$refs["autorizador"];
      let invalid = true;
      for (let index in autorizador) {
        if (autorizador[index].$v.$invalid) {
          invalid = false;
          break;
        }
      }
      return invalid;
    },
    touchAutorizadores() {
      let autorizadores = this.$refs["autorizador"];
      for (let index in autorizadores) {
        autorizadores[index].$v.$touch();
      }
    },
    agregaRevisor() {
      this.touchRevisores();
      let isValidRevisores = this.isValidRevisores();
      let newRevisor = JSON.parse(JSON.stringify(firmaRevisor));
      if (isValidRevisores) {
        this.revisores.push(newRevisor);
      }
    },
    agregaAutorizador() {
      this.touchAutorizadores();
      let isValidAutorizadores = this.isValidAutorizadores();
      let newAutorizador = JSON.parse(JSON.stringify(firmaAutorizador));
      if (isValidAutorizadores) {
        this.autorizadores.push(newAutorizador);
      }
    },
    borrarFirma(firma) {
      if (firma.idJerarquia == 1) {
        if (this.revisores.length > 1) {
          this.revisores = this.revisores.filter(
            (itemFirma) => itemFirma.idFirma != firma.idFirma
          );
        } else {
          this.resetRevisores();
        }
      } else {
        if (this.autorizadores.length > 1) {
          this.autorizadores = this.autorizadores.filter(
            (itemFirma) => itemFirma.idFirma != firma.idFirma
          );
        } else {
          this.resetAutorizadores();
        }
      }
    },
    validFirma(firma) {
      this.postFirma(firma, false);
    },
    resetRevisores() {
      this.revisores = [];
      this.revisores.push(JSON.parse(JSON.stringify(firmaRevisor)));
    },
    resetAutorizadores() {
      this.autorizadores = [];
      this.autorizadores.push(JSON.parse(JSON.stringify(firmaAutorizador)));
    },
    getFirmasFolio() {
      axios("/modelo-negocio/folio-firmas/v1/" + this.folio.idFolio + "/firmas")
        .then((response) => {
          let data = response.data;
          if (data) {
            let firmas = data.resultado.firmas;
            firmas.forEach((itemFirma) => {
              if (itemFirma.idJerarquia == 1) {
                this.revisores.push(itemFirma);
              } else {
                this.autorizadores.push(itemFirma);
              }
            });
            if (!this.revisores || this.revisores.length < 1) {
              this.resetRevisores();
            }
            if (!this.autorizadores || this.autorizadores.length < 1) {
              this.resetAutorizadores();
            }
          }
        })
        .catch((error) => {
          if (error.response) {
            if (error.response.status == 404) {
              this.resetRevisores();
              this.resetAutorizadores();
            }
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },
    postFirma(firma, actualizar) {
      let body = {
        idFirma: firma.idFirma,
        numeroEmpleado: firma.numeroEmpleado,
        idJerarquia: firma.idJerarquia,
        indice: firma.indice,
      };
      axios
        .post(
          "/modelo-negocio/folio-firmas/v1/" + this.folio.idFolio + "/firmas",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            firma.idFirma = data.resultado.id;
          }
        })
        .catch((error) => {
          if (error.response) {
            firma.numeroEmpleado = null;
            console.log(error.response.data);
          }
        });
    },
    deleteFirma(firma) {
      const self = this;
      axios
        .delete(
          "/modelo-negocio/folio-firmas/v1/" +
            this.folio.idFolio +
            "/firmas/" +
            firma.idFirma
        )
        .then((response) => {
          this.revisores = [];
          this.autorizadores = [];
          this.getFirmasFolio();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    cleared(firma) {
      console.log(firma);
      if (firma.idFirma) {
        this.deleteFirma(firma);
      } else {
        this.borrarFirma(firma);
      }
    },
  },
  created() {
    this.getFirmasFolio();
  },
};
</script>
